
import java.util.ArrayList;


class hashtable {

    private int htablesize = 101;
    private Cell[] htable; 

    public hashtable(int size) {
	htablesize = size;
	htable = new Cell[htablesize];
	for (int i=0; i<htablesize; i++) htable[i] = null;
    }

    public void add(String s) {
	int h = hash(s);
	htable[h] = new Cell(s, htable[h]);	// what does this do?
    }

    public boolean isMember(String s) {
	int h = hash(s);
	Cell p = htable[h];
	while (p!=null) {
		if (s == p.getString()) return true;
		p = p.next();
	}
	return false;
    }

    public void print() {
	for (int i = 0; i<htablesize; i++) {
	    Cell p = htable[i];
	    while (p!= null) {
		System.out.println(p.getString());
		p = p.next();
	    }
	}
    }

    public int hash(String s) {
	    int h = s.hashCode() % htablesize;
	    if (h<0) h+= htablesize;	// stupid negative numbers
	    return h;
    }

    public class Cell {
	    private String s_;
	    private Cell  next_;
	    public Cell(String s, Cell n) {s_ = s; next_ = n;}
	    public String getString() {return s_;}
	    public Cell   next() {return next_;}
        public void setString(String s) {s_ = s;}
        public void setNext(Cell c)   {next_ = c;}
    }	
}

